/*****************************************************************************
 * $Source: /expand6/cvsroot/charm/src/Common/libs/ck-libs/barrier/barrier.h,v $
 * $Author: milind $
 * $Date: 2000/06/13 22:11:16 $
 * $Revision: 1.1 $
 *****************************************************************************/

#include "Barrier.decl.h"

typedef void (*voidfn)();
extern int barrierInit(void);

class FP : public CMessage_FP
{
public:
  voidfn fp;
};

class barrier : public Group 
{
  int myPe, myLeft, myRight, myParent, myGroup;
  int kidscount;
  voidfn fnptr;

public:
  /* entry methods */
  barrier(void);
  void notify(void);
  void callFP(void);
  void reset(void);
  void atBarrier(FP *);
};
